VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "FileClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Inorder to have high security the properties are made non accessable (private)
Private nMode As Integer ' to select read write binary random sequential file opening
Private bErrorMsgbox As Boolean ' to select to message box on error if this is true
Private bFileIsOpen As Boolean 'To tell me that a file has been opened
Private bUserAbort As Boolean 'To allow users to abort your program
Private nErrorcode As Integer 'the error code of I/O errors held here
Private sErrortext As String 'The description if of I/O errors held here
Private nRecordLenght As Integer 'The length of the Record to be opened (random file)
Private nFileNum As Integer 'The current file tag number
Private nLoopCnt As Integer 'number of retries before prompting user

'---Open Mode Constants ------------------------
' OpenSequentialInput = 1
' OpenSequentialOutput = 2
' OpenSequentialAppend = 3
' OpenRandom = 4
' OpenSequentialBinaryWrite = 5
' OpenSequentialBinaryRead = 6


 Const OpenReadOnly = 1000
 Const OpenWriteOnly = 2000
 Const OpenReadWrite = 3000
 Const OpenReadLock = 100
 Const OpenWriteLock = 200
 Const OpenReadWriteLock = 300
 Const Openshared = 400
  
 Const OpenSequentialInput = 1
 Const OpenSequentialOutput = 2
 Const OpenSequentialAppend = 3
 Const OpenRandom = 4
 Const OpenSequentialBinaryWrite = 5
 Const OpenSequentialBinaryRead = 6
 '---------------------------------------------------
 

Public Sub wait(nSeconds As Integer)
    Dim start As Single
     
    start = Timer   ' Set start time.
    Do While Timer < start + nSeconds
        DoEvents    ' Yield to other processes.
    Loop
    
End Sub
Private Sub Class_Initialize() 'My Classes  C++ constructor function
     bUserAbort = True 'allow user to abort program
     bFileIsOpen = False 'To tell me that a file has been opened
     bErrorMsgbox = False ' to select to message box on error if this is true
     nErrorcode = 0 'Storing error code to Property
     sErrortext = "Sucessfull" 'Storing error text to Property
     nMode = OpenSequentialInput ' + OpenReadWrite + Openshared 'Default mode
     
End Sub

Private Sub Class_Terminate() 'My Classes  C++ destructor function
     If bFileIsOpen = True Then
          CloseFile
     End If
End Sub

Public Sub SetMode(Mode As Integer) 'Users application passes mode
    nMode = Mode 'if a non zero mode passed store it
End Sub

Public Sub SetnRecordLenght(RecordLenght As Integer) 'Users application passes record lenght
     nRecordLenght = RecordLenght 'Store record length passed by users application
End Sub
Public Sub AlowUserAbort(bYes As Boolean)
    bUserAbort = bYes
End Sub
Public Sub SetErrorMode(bYes As Boolean) 'Users application passes error messagebox  flag
    bErrorMsgbox = bYes 'True will  select to message box on error if this is true
End Sub

Public Function ReturnErrorCode() As Integer
     ReturnErrorCode = nErrorcode 'Return the I/O error code to users application
End Function
Public Function ReturnErrortext() As String
     ReturnErrortext = sErrortext 'Return the I/O error text to users application
End Function

Public Sub ErrorMsgbox() ' if  bErrorMsgbox = bYes =="True" will  select to message box on error calling this function
          MsgBox ("File I/O  Error " & nErrorcode & "  " & sErrortext)
End Sub
Public Sub ShowStatus() ' in a message box
    MsgBox "Current Mode=" & nMode & Chr(13) & _
    "File is open =" & bFileIsOpen & Chr(13) & _
    "Current File Handle = #" & nFileNum & _
    "Random File Record Length = " & nRecordLenght & _
    "Display error message boxes=" & bErrorMsgbox & Chr(13) & _
    "I/O Error Code =" & nErrorcode & Chr(13) & _
    "I/O Error = " & sErrortext
End Sub
Public Function ErrorHandler() As Integer 'returns valu based on

          'vbAbort  3   Abort button pressed
          'vbRetry  4   Retry button pressed
          'vbIgnore 5   Ignore button pressed
            
          Const nErrorTimeOut = 6 'repeat error handler 6 times before prompting user
        
          Dim iError As Integer 'get users input for error message box (retry abort ignore)
          Dim sError As String 'the I/O error description
          Dim iReturnCode  ' the return code of this function
        
          Debug.Print Err.Number
          Debug.Print Err.Description
          Debug.Print nLoopCnt

          nErrorcode = Err.Number 'Storing error code to Property
          sErrortext = Err.Description 'Storing error text to Property
          iReturnCode = 0
         
          If bErrorMsgbox = True Then ErrorMsgbox
          sError = "File I/O   Error " & Err.Number & " " & Err.Description
         
          'MsgBox (Err.Description)
          'MsgBox ("Loop=" & Str(nLoopCnt))
        
          If bErrorMsgbox = True Then
        
               iError = MsgBox(sError, vbAbortRetryIgnore, "File I/O   Error ")
                        
               If iError = 3 Then 'abort
                    iReturnCode = 3
               End If
            
               If iError = 4 Then 'retry
                    iReturnCode = 4
               End If
            
               If iError = 5 Then 'ignore
                    iReturnCode = 5
               End If
          Else
               iReturnCode = 1 'ie user not prompted for error
          End If
        
          ErrorHandler = iReturnCode
          
End Function


Public Sub WriteFile(sString As String) 'this write a string to disk with error handling
     Dim iRetcode As Integer
     
          nLoopCnt = 0
 On Error GoTo ErrorLoop
        GoTo NoError
ErrorLoop:
        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
         
        If iRetcode = 1 Then
          GoTo Finish
        End If
                
NoError:
          Print #nFileNum, sString
Finish:
End Sub


Public Function ReadFile() As String
  Dim iRetcode As Integer
  Dim sTemp As String
     
          nLoopCnt = 0
 On Error GoTo ErrorLoop
        GoTo NoError
ErrorLoop:
        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
        
        If iRetcode = 1 Then
          GoTo Finish
        End If
        
        
NoError:
     sTemp = ""
     Line Input #nFileNum, sTemp
     ReadFile = sTemp
Finish:
End Function

Public Sub OpenFile(sFileName As String, Mode As Integer)
     If Mode <> 0 Then nMode = Mode
    Dim iRetcode As Integer
    
        nFileNum = FreeFile    ' Get unused file tag
        nErrorcode = 0 'Storing error code to Property
        sErrortext = "Sucessfull" 'Storing error text to Property
        
    
 On Error GoTo ErrorLoop
        GoTo NoError
ErrorLoop:
        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
        
        If iRetcode = 1 Then
          GoTo Finish
        End If
        
NoError:

     Select Case nMode
        Case OpenSequentialInput '1
            Open sFileName For Input As #nFileNum
            
        Case OpenSequentialOutput '2
            Open sFileName For Output Shared As #nFileNum
            
        Case OpenSequentialAppend '3
            Open sFileName For Append Shared As #nFileNum
            
        Case OpenRandom '4
            Open sFileName For Random As #nFileNum Len = nRecordLenght
            
        Case OpenSequentialBinaryWrite '5
            Open sFileName For Binary Access Write As #nFileNum
           
        Case OpenSequentialBinaryRead '6
            Open sFileName For Binary Access Read Lock Read As #nFileNum
           
        Case Else
            MsgBox ("Mode " & nMode & "not valid")
     End Select
Finish:
End Sub

Public Sub CloseFile()
Dim iRetcode As Integer
     
          nLoopCnt = 0
 On Error GoTo ErrorLoop
        GoTo NoError
ErrorLoop:
        iRetcode = ErrorHandler
        
        If iRetcode = 3 Then
          If bUserAbort = True Then End
        End If
        
        If iRetcode = 4 Then
          Resume
        End If
        
        If iRetcode = 5 Then
          Resume Next
        End If
        
        If iRetcode = 1 Then
          GoTo Finish
        End If
        
NoError:
     Close #nFileNum
Finish:
     
End Sub




